#include <stdio.h>
#include <stdlib.h>

typedef struct s_maillon *p_maillon;

typedef struct s_maillon
{
  p_maillon suivant;
  int	    contenu;
} t_maillon;

/* la liste vide sera dfinie comme un pointeur NULL */
typedef p_maillon t_liste;

t_liste nil(void)
{
  return (struct s_maillon *)NULL;
}

t_liste cons(int element, t_liste liste)
{
  t_liste p;

  p = (t_liste)malloc(sizeof(t_maillon));
  p->contenu = element;
  p->suivant = liste;
  return p;
}


void afficheliste(t_liste l)
{
  p_maillon p;

  printf("|");
  
  for(p=l;p;p=p->suivant){
	printf("%d|",p->contenu);
  }
  printf("\n");
  return;
}

p_maillon tab2list(int tab[], int taille)
{
  int i;
  p_maillon q,r;
  
  for(i=0,r=nil();i<taille;i++){
	q=cons(tab[i],r);
	r=q;
  }
  return r;
}

int main(void)
{
  int t[] = {32,52,33};
  
  t_liste l0=tab2list(t,3);

  afficheliste(l0);
  afficheliste(NULL);
  
  return 0;
}

  

